local RW = LibStub("AceAddon-3.0"):GetAddon("Raid Watch")
local plugin = RW:Plugin("LoD")
if not plugin then return end

function plugin:OnRegister()
	plugin.loadZones = {}
end

function plugin:PluginEnable()
	for i = 1, GetNumAddOns() do
		if GetAddOnMetadata(i, "X-RW-Mod") and select(4, GetAddOnInfo(i)) then
			local name 	= GetAddOnMetadata(i, "X-RW-Name") or ""
			local zone	= {strsplit(",", GetAddOnMetadata(i, "X-RW-Zone") or "")}
			local modId	= GetAddOnInfo(i)
			local loadInfo = {name = name, modId = modId}
			
			self:SendMessage("RW_BossModFound", name, modId)
			
			for i, zoneName in pairs(zone) do
				self.loadZones[zoneName] = self.loadZones[zoneName] or {}
				tinsert(self.loadZones[zoneName], loadInfo)
				self:SendMessage("RW_NewMonitorZone", zoneName)
			end
		end
	end
	self:RegisterEvent("ZONE_CHANGED_NEW_AREA")
	
	self:ScheduleTimer("ZONE_CHANGED_NEW_AREA", 1)
end

function plugin:PluginDisable()
	wipe(plugin.loadZones)
end

function plugin:ZONE_CHANGED_NEW_AREA(event)
	local zone = GetRealZoneText()
	if self.loadZones[zone] then
		for i, mod in pairs(self.loadZones[zone]) do
			if not IsAddOnLoaded(mod.modId) then
				self:LoadMod(mod.modId, mod.name)
			end
		end
		self.loadZones[zone] = nil
	end
end

function plugin:LoadMod(modID, modName)
	local loaded, reason = LoadAddOn(modID)
	if loaded then
		RW:Msg("Loaded "..modName)
		return true
	else
		self:Msg("Could not load "..modName ..", Reason: " ..reason)
		return false
	end
end
